#! /usr/local/bin/perl -w
#/*
#//  The Natto View
#//
#//  Copyright (c) 1996  Hidekazu Shiozawa <shiozawa@myo.inst.keio.ac.jp>
#//                      Keio University (Matsushita Lab.)
#//
#//  Please first read the full copyright statement in the file LICENSE.
#//  The code in this file may be used, copied and redistributed under the
#//  same terms as perl itself (see the files README, Copying and Artistic
#//  in the perl distribution).
#*/

use strict;
#use diagnostics;

my %entities;

undef $/;
$_ = <>;

s/<!--(.*?)-->//gsx;
s/--(.*?)--//gsx;
s/<!\[(.*?)\]>/$1/gsx;
s/%\s*/%/gs;
s/\s*\|\s*/\|/gs;
s/\(\s*//gs;
s/\s*\)//gs;

s/<!ENTITY\s+(\S+)\s+(.*?)\s*>/entity($1, $2)/gsex;

sub entity
{
    my($key, $value) = @_;
    if ($key !~ /^%/) {
        $value =~ s/CDATA//;
        $value =~ s/^\s*\"(.*?)\"\s*$/$1/x;
	$value .= ';' unless $value =~ /;$/;
        print "0-ENTITY $key\t$value\n" if $value =~ /&#\d+;/
    }
    else {
        $value =~ s/^["']\s*//;
        $value =~ s/\s*["']$//;
	$entities{lc $key} = $value;
    }
    '';
}
    
1 while s/(%[\w.-]+);?/$entities{lc $1}/gse;

s/<!ELEMENT\s+(\S+)\s+([-O])\s+([-O])\s+(.*?)\s*>/
    element(lc $1, $2, $3, $4)/gsex;

sub element
{
    my($key, $start, $stop, $content) = @_;
    my $elem;
    foreach $elem (split(/\|/, $key)) {
	next if $elem =~ /(head)|(body)|(option)/ && $stop eq '-';
	next if $elem =~ /style/ && $stop eq 'O';
        print "1-ELEMENT $elem\t0-new\t$start $stop\n";
    }
    '';
}

1 while s/(\#FIXED)\s*["'][^"']*["']/$1/gs;

s/<!ATTLIST\s+(\S+)\s+(.*?)\s*>/attlist(lc $1, $2)/gsex;

sub attlist
{
    my($key, $attrs) = @_;
    $key =~ s/^\(\s*//;
    $key =~ s/\s*\)$//;
#    $attrs =~ s/(\#FIXED)\s*["'][^"']*["']/$1/gsx;
    while ($attrs =~ s/^\s*(\S+)\s+(\S+)\s*(\S+)//s) {
        my $a = lc $1;
        $a =~ s/^\'\s*//;
        $a =~ s/\s*\'$//;
	next if $a =~ /"/;
	my $elem;
        foreach $elem (split(/\|/, $key)) {
	    print "1-ELEMENT $elem\t1-att\t$a\n";
	}
    }
    '';
}
