/*
//  ANSI C prototypes for libcci functions by shiozawa@myo.inst.keio.ac.jp
*/ 

#ifndef LIBCCI_H
#define LIBCCI_H
#ifdef __cplusplus
extern "C" {
#endif    

typedef void (*MCCICallbackProc)();
typedef void*  MCCICallbackData;

MCCIPort MCCIConnect(char* address, int port,
		     MCCICallbackProc proc, MCCICallbackData data);
int  MCCIDisconnect(MCCIPort);
int  MCCIPoll(MCCIPort);
int  MCCIGetSocketDescriptor(MCCIPort);
int  MCCIIsConnected(MCCIPort);
int  MCCIIsThereInput(MCCIPort);

int  MCCIGet(MCCIPort cciport, char* uri, int output,
	     int absRelative, char* additionalHeader);
int  MCCINBGet(MCCIPort cciport, char* uri, int output,
	       int absRelative, char* additionalHeader);
int  MCCISendAnchor(MCCIPort cciport, int status,
		    MCCICallbackProc proc, MCCICallbackData data);
int  MCCISendOutput(MCCIPort cciportPort, char* mimeType,
		    MCCICallbackProc proc, MCCICallbackData data);
int  MCCISendOutputStop(MCCIPort cciport, char* mimeType);
int  MCCIPost(MCCIPort cciport, char* url, char* contentType,
	      char* data, int dataLength, int output);
void MCCIReadBrowserViewOutput(MCCIPort cciport, char* response);
int  MCCISendBrowserView(MCCIPort cciport, int status,
			 MCCICallbackProc proc , MCCICallbackData data);

#ifdef __cplusplus
}
#endif    
#endif /* LIBCCI_H */
