#############################################################################
# Visual Tcl v1.07 Project
#

#################################
# GLOBAL VARIABLES
#
global fifo; set fifo {file4}
global widget; 
#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {
global fifo
    set fifo [open "/tmp/natto_fifo" w]
}

init $argc $argv


proc putcmd {str} {
global fifo
    puts $fifo $str
    flush $fifo
}

proc main {argc argv} {

}

proc Window {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set rest [lrange $args 2 end]
    if {$name == "" || $cmd == ""} {return}
    set exists [winfo exists $name]
    switch $cmd {
        show {
            if {[info procs vTclWindow(pre)$name] != ""} {
                vTclWindow(pre)$name $rest
            }
            if {[info procs vTclWindow$name] != ""} {
                vTclWindow$name
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                vTclWindow(post)$name $rest
            }
        }
        hide    { if $exists {wm withdraw $name; return} }
        iconify { if $exists {wm iconify $name; return} }
        destroy { if $exists {destroy $name; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {args} {
    set base .
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel . passive
    wm geometry . 1x1+0+0
    wm maxsize . 1265 994
    wm minsize . 1 1
    wm overrideredirect . 0
    wm resizable . 1 1
    wm withdraw .
    wm title . "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {args} {
    set base .top17
    if {[winfo exists .top17]} {
        wm deiconify .top17; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel .top17 -class Toplevel
    wm focusmodel .top17 passive
    wm geometry .top17 190x180+103+390
    wm maxsize .top17 190 180
    wm minsize .top17 190 180
    wm overrideredirect .top17 0
    wm resizable .top17 1 1
    wm deiconify .top17
    wm title .top17 "NattoView - Panel"
    frame .top17.fra19 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    button .top17.fra19.but20 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text W 
    bind .top17.fra19.but20 <ButtonRelease-1> {
        putcmd "TY+"
    }
    button .top17.fra19.but21 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text S 
    bind .top17.fra19.but21 <ButtonRelease-1> {
        putcmd "TX-"
    }
    button .top17.fra19.but22 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text A 
    bind .top17.fra19.but22 <ButtonRelease-1> {
        putcmd "TX+"
    }
    button .top17.fra19.but23 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text Z 
    bind .top17.fra19.but23 <ButtonRelease-1> {
        putcmd "TY-"
    }
    button .top17.fra19.but24 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text E 
    bind .top17.fra19.but24 <ButtonRelease-1> {
        putcmd "ZZ-"
    }
    button .top17.fra19.but25 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text X 
    bind .top17.fra19.but25 <ButtonRelease-1> {
        putcmd "ZZ+"
    }
    button .top17.fra19.but26 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text D 
    bind .top17.fra19.but26 <ButtonRelease-1> {
        putcmd "RY+"
    }
    button .top17.fra19.but27 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text R 
    bind .top17.fra19.but27 <ButtonRelease-1> {
        putcmd "RX+"
    }
    button .top17.fra19.but28 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text F 
    bind .top17.fra19.but28 <ButtonRelease-1> {
        putcmd "RY-"
    }
    button .top17.fra19.but29 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text C 
    bind .top17.fra19.but29 <ButtonRelease-1> {
        putcmd "RX-"
    }
    frame .top17.fra30 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    button .top17.fra30.but17 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text Up 
    bind .top17.fra30.but17 <ButtonRelease-1> {
        putcmd "UP"
    }
    button .top17.fra30.but18 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text Down 
    bind .top17.fra30.but18 <ButtonRelease-1> {
        putcmd "DOWN"
    }
    button .top17.fra30.but19 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text {Down All} 
    bind .top17.fra30.but19 <ButtonRelease-1> {
        putcmd "ALL"
    }
    button .top17.fra30.but20 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text Browse 
    bind .top17.fra30.but20 <ButtonRelease-1> {
        putcmd "BROWSE"
    }
    button .top17.fra30.but22 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text Quit 
    bind .top17.fra30.but22 <ButtonRelease-1> {
        putcmd "QUIT"
	exit 0
    }
    button .top17.fra30.but23 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text Reload 
    bind .top17.fra30.but23 <ButtonRelease-1> {
        putcmd "LOAD"
    }
    ###################
    # SETTING GEOMETRY
    ###################
    place .top17.fra19 \
        -x 5 -y 5 -width 180 -height 95 -anchor nw -bordermode ignore 
    place .top17.fra19.but20 \
        -x 25 -y 5 -width 30 -anchor nw -bordermode ignore 
    place .top17.fra19.but21 \
        -x 40 -y 35 -width 30 -anchor nw -bordermode ignore 
    place .top17.fra19.but22 \
        -x 5 -y 35 -width 30 -anchor nw -bordermode ignore 
    place .top17.fra19.but23 \
        -x 25 -y 65 -width 30 -anchor nw -bordermode ignore 
    place .top17.fra19.but24 \
        -x 75 -y 5 -width 30 -anchor nw -bordermode ignore 
    place .top17.fra19.but25 \
        -x 75 -y 65 -width 30 -anchor nw -bordermode ignore 
    place .top17.fra19.but26 \
        -x 110 -y 35 -width 30 -anchor nw -bordermode ignore 
    place .top17.fra19.but27 \
        -x 125 -y 5 -width 30 -anchor nw -bordermode ignore 
    place .top17.fra19.but28 \
        -x 145 -y 35 -width 30 -anchor nw -bordermode ignore 
    place .top17.fra19.but29 \
        -x 125 -y 65 -width 30 -anchor nw -bordermode ignore 
    place .top17.fra30 \
        -x 5 -y 105 -width 180 -height 65 -anchor nw -bordermode ignore 
    place .top17.fra30.but17 \
        -x 5 -y 5 -width 35 -anchor nw -bordermode ignore 
    place .top17.fra30.but18 \
        -x 45 -y 5 -width 55 -anchor nw -bordermode ignore 
    place .top17.fra30.but19 \
        -x 105 -y 5 -width 70 -anchor nw -bordermode ignore 
    place .top17.fra30.but20 \
        -x 5 -y 35 -width 55 -anchor nw -bordermode ignore 
    place .top17.fra30.but22 \
        -x 130 -y 35 -anchor nw -bordermode ignore 
    place .top17.fra30.but23 \
        -x 65 -y 35 -width 60 -anchor nw -bordermode ignore 
}

Window show .
Window show .top17

main $argc $argv
